Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 7299)
@@ -8,11 +8,7 @@
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
    !!            3.5  !  2012     (S. Mocavero, I. Epicoco) Optimization of BDY communications
+   !!            4.0  !  2016     (T. Lovato) Generalize OBC structure
    !!----------------------------------------------------------------------
-#if defined key_bdy
-   !!----------------------------------------------------------------------
-   !!   'key_bdy'                     Unstructured Open Boundary Conditions
-   !!----------------------------------------------------------------------
-   !!   bdy_tra            : Apply open boundary conditions to T and S
-   !!   bdy_tra_frs        : Apply Flow Relaxation Scheme
+   !!   bdy_tra       : Apply open boundary conditions & damping to T and S
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers variables
@@ -20,5 +16,4 @@
    USE bdy_oce        ! ocean open boundary conditions
    USE bdylib         ! for orlanski library routines
-   USE bdydta   , ONLY:   bf   ! 
    !
    USE in_out_manager ! I/O manager
@@ -29,9 +24,14 @@
    PRIVATE
 
+   ! Local structure to rearrange tracers data
+   TYPE, PUBLIC ::   ztrabdy
+      REAL(wp), POINTER, DIMENSION(:,:) ::  tra
+   END TYPE
+
    PUBLIC   bdy_tra      ! called in tranxt.F90 
    PUBLIC   bdy_tra_dmp  ! called in step.F90 
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0, NEMO Consortium (2016)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
@@ -48,198 +48,45 @@
       INTEGER, INTENT(in) ::   kt   ! Main time step counter
       !
-      INTEGER ::   ib_bdy   ! Loop index
+      INTEGER                        :: ib_bdy, jn   ! Loop indeces
+      TYPE(ztrabdy), DIMENSION(jpts) :: zdta         ! Temporary data structure
       !!----------------------------------------------------------------------
 
       DO ib_bdy=1, nb_bdy
          !
-         SELECT CASE( cn_tra(ib_bdy) )
-         CASE('none'        )   ;   CYCLE
-         CASE('frs'         )   ;   CALL bdy_tra_frs     ( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE('specified'   )   ;   CALL bdy_tra_spe     ( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE('neumann'     )   ;   CALL bdy_tra_nmn     ( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE('orlanski'    )   ;   CALL bdy_tra_orlanski( idx_bdy(ib_bdy), dta_bdy(ib_bdy), ll_npo=.false. )
-         CASE('orlanski_npo')   ;   CALL bdy_tra_orlanski( idx_bdy(ib_bdy), dta_bdy(ib_bdy), ll_npo=.true. )
-         CASE('runoff'      )   ;   CALL bdy_tra_rnf     ( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE DEFAULT           ;   CALL ctl_stop( 'bdy_tra : unrecognised option for open boundaries for T and S' )
-         END SELECT
-         ! Boundary points should be updated
-         CALL lbc_bdy_lnk( tsa(:,:,:,jp_tem), 'T', 1., ib_bdy )
-         CALL lbc_bdy_lnk( tsa(:,:,:,jp_sal), 'T', 1., ib_bdy )
+         zdta(1)%tra => dta_bdy(ib_bdy)%tem
+         zdta(2)%tra => dta_bdy(ib_bdy)%sal
+         !
+         DO jn = 1, jpts
+            !
+            SELECT CASE( TRIM(cn_tra(ib_bdy)) )
+            CASE('none'        )   ;   CYCLE
+            CASE('frs'         )   ;   CALL bdy_frs ( idx_bdy(ib_bdy),                tsa(:,:,:,jn), zdta(jn)%tra )
+            CASE('specified'   )   ;   CALL bdy_spe ( idx_bdy(ib_bdy),                tsa(:,:,:,jn), zdta(jn)%tra )
+            CASE('neumann'     )   ;   CALL bdy_nmn ( idx_bdy(ib_bdy),                tsa(:,:,:,jn)               )
+            CASE('orlanski'    )   ;   CALL bdy_orl ( idx_bdy(ib_bdy), tsb(:,:,:,jn), tsa(:,:,:,jn), zdta(jn)%tra, ll_npo=.false. )
+            CASE('orlanski_npo')   ;   CALL bdy_orl ( idx_bdy(ib_bdy), tsb(:,:,:,jn), tsa(:,:,:,jn), zdta(jn)%tra, ll_npo=.true. )
+            CASE('runoff'      )   ;   CALL bdy_rnf ( idx_bdy(ib_bdy),                tsa(:,:,:,jn),               jn )
+            CASE DEFAULT           ;   CALL ctl_stop( 'bdy_tra : unrecognised option for open boundaries for T and S' )
+            END SELECT
+            ! Boundary points should be updated
+            CALL lbc_bdy_lnk( tsa(:,:,:,jn), 'T', 1., ib_bdy )
+            ! 
+         END DO
       END DO
       !
    END SUBROUTINE bdy_tra
 
-
-   SUBROUTINE bdy_tra_frs( idx, dta, kt )
+   SUBROUTINE bdy_rnf( idx, pta, jpa )
       !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra_frs  ***
+      !!                 ***  SUBROUTINE bdy_rnf  ***
       !!                    
-      !! ** Purpose : Apply the Flow Relaxation Scheme for tracers at open boundaries.
-      !! 
-      !! Reference : Engedahl H., 1995, Tellus, 365-382.
-      !!----------------------------------------------------------------------
-      INTEGER,         INTENT(in) ::   kt    !
-      TYPE(OBC_INDEX), INTENT(in) ::   idx   ! OBC indices
-      TYPE(OBC_DATA),  INTENT(in) ::   dta   ! OBC external data
-      !
-      REAL(wp) ::   zwgt           ! boundary weight
-      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
-      INTEGER  ::   ii, ij         ! 2D addresses
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start('bdy_tra_frs')
-      !
-      igrd = 1                       ! Everything is at T-points here
-      DO ib = 1, idx%nblen(igrd)
-         DO ik = 1, jpkm1
-            ii = idx%nbi(ib,igrd)
-            ij = idx%nbj(ib,igrd)
-            zwgt = idx%nbw(ib,igrd)
-            tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) + zwgt * ( dta%tem(ib,ik) - tsa(ii,ij,ik,jp_tem) ) ) * tmask(ii,ij,ik)         
-            tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) + zwgt * ( dta%sal(ib,ik) - tsa(ii,ij,ik,jp_sal) ) ) * tmask(ii,ij,ik)
-         END DO
-      END DO 
-      !
-      IF( kt .eq. nit000 )   CLOSE( unit = 102 )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_tra_frs')
-      !
-   END SUBROUTINE bdy_tra_frs
-
-
-   SUBROUTINE bdy_tra_spe( idx, dta, kt )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra_frs  ***
-      !!                    
-      !! ** Purpose : Apply a specified value for tracers at open boundaries.
+      !! ** Purpose : Specialized routine to apply TRA runoff values at OBs:
+      !!                  - duplicate the neighbour value for the temperature
+      !!                  - specified to 0.1 PSU for the salinity
       !! 
       !!----------------------------------------------------------------------
-      INTEGER,         INTENT(in) ::   kt    !
-      TYPE(OBC_INDEX), INTENT(in) ::   idx   ! OBC indices
-      TYPE(OBC_DATA),  INTENT(in) ::   dta   ! OBC external data
-      !
-      REAL(wp) ::   zwgt           ! boundary weight
-      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
-      INTEGER  ::   ii, ij         ! 2D addresses
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_spe')
-      !
-      igrd = 1                       ! Everything is at T-points here
-      DO ib = 1, idx%nblenrim(igrd)
-         ii = idx%nbi(ib,igrd)
-         ij = idx%nbj(ib,igrd)
-         DO ik = 1, jpkm1
-            tsa(ii,ij,ik,jp_tem) = dta%tem(ib,ik) * tmask(ii,ij,ik)
-            tsa(ii,ij,ik,jp_sal) = dta%sal(ib,ik) * tmask(ii,ij,ik)
-         END DO
-      END DO
-      !
-      IF( kt == nit000 )   CLOSE( unit = 102 )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_tra_spe')
-      !
-   END SUBROUTINE bdy_tra_spe
-
-
-   SUBROUTINE bdy_tra_nmn( idx, dta, kt )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra_nmn  ***
-      !!                    
-      !! ** Purpose : Duplicate the value for tracers at open boundaries.
-      !! 
-      !!----------------------------------------------------------------------
-      INTEGER,         INTENT(in) ::   kt    ! 
-      TYPE(OBC_INDEX), INTENT(in) ::   idx   ! OBC indices
-      TYPE(OBC_DATA) , INTENT(in) ::   dta   ! OBC external data
-      !
-      REAL(wp) ::   zwgt           ! boundary weight
-      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
-      INTEGER  ::   ii, ij,zcoef, zcoef1,zcoef2, ip, jp   ! 2D addresses
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start('bdy_tra_nmn')
-      !
-      igrd = 1                       ! Everything is at T-points here
-      DO ib = 1, idx%nblenrim(igrd)
-         ii = idx%nbi(ib,igrd)
-         ij = idx%nbj(ib,igrd)
-         DO ik = 1, jpkm1
-            ! search the sense of the gradient
-            zcoef1 = bdytmask(ii-1,ij  ) +  bdytmask(ii+1,ij  )
-            zcoef2 = bdytmask(ii  ,ij-1) +  bdytmask(ii  ,ij+1)
-            IF ( zcoef1+zcoef2 == 0) THEN
-               ! corner
-               zcoef = tmask(ii-1,ij,ik) + tmask(ii+1,ij,ik) +  tmask(ii,ij-1,ik) +  tmask(ii,ij+1,ik)
-               tsa(ii,ij,ik,jp_tem) = tsa(ii-1,ij  ,ik,jp_tem) * tmask(ii-1,ij  ,ik) + &
-                 &                    tsa(ii+1,ij  ,ik,jp_tem) * tmask(ii+1,ij  ,ik) + &
-                 &                    tsa(ii  ,ij-1,ik,jp_tem) * tmask(ii  ,ij-1,ik) + &
-                 &                    tsa(ii  ,ij+1,ik,jp_tem) * tmask(ii  ,ij+1,ik)
-               tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) / MAX( 1, zcoef) ) * tmask(ii,ij,ik)
-               tsa(ii,ij,ik,jp_sal) = tsa(ii-1,ij  ,ik,jp_sal) * tmask(ii-1,ij  ,ik) + &
-                 &                    tsa(ii+1,ij  ,ik,jp_sal) * tmask(ii+1,ij  ,ik) + &
-                 &                    tsa(ii  ,ij-1,ik,jp_sal) * tmask(ii  ,ij-1,ik) + &
-                 &                    tsa(ii  ,ij+1,ik,jp_sal) * tmask(ii  ,ij+1,ik)
-               tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) / MAX( 1, zcoef) ) * tmask(ii,ij,ik)
-            ELSE
-               ip = bdytmask(ii+1,ij  ) - bdytmask(ii-1,ij  )
-               jp = bdytmask(ii  ,ij+1) - bdytmask(ii  ,ij-1)
-               tsa(ii,ij,ik,jp_tem) = tsa(ii+ip,ij+jp,ik,jp_tem) * tmask(ii+ip,ij+jp,ik)
-               tsa(ii,ij,ik,jp_sal) = tsa(ii+ip,ij+jp,ik,jp_sal) * tmask(ii+ip,ij+jp,ik)
-            ENDIF
-         END DO
-      END DO
-      !
-      IF( kt == nit000 )   CLOSE( unit = 102 )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_tra_nmn')
-      !
-   END SUBROUTINE bdy_tra_nmn
- 
-
-   SUBROUTINE bdy_tra_orlanski( idx, dta, ll_npo )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra_orlanski  ***
-      !!             
-      !!              - Apply Orlanski radiation to temperature and salinity. 
-      !!              - Wrapper routine for bdy_orlanski_3d
-      !! 
-      !!
-      !! References:  Marchesiello, McWilliams and Shchepetkin, Ocean Modelling vol. 3 (2001)    
-      !!----------------------------------------------------------------------
-      TYPE(OBC_INDEX), INTENT(in) ::   idx     ! OBC indices
-      TYPE(OBC_DATA) , INTENT(in) ::   dta     ! OBC external data
-      LOGICAL        , INTENT(in) ::   ll_npo  ! switch for NPO version
-      !
-      INTEGER  ::   igrd                                    ! grid index
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_orlanski')
-      !
-      igrd = 1      ! Orlanski bc on temperature; 
-      !            
-      CALL bdy_orlanski_3d( idx, igrd, tsb(:,:,:,jp_tem), tsa(:,:,:,jp_tem), dta%tem, ll_npo )
-
-      igrd = 1      ! Orlanski bc on salinity;
-      !  
-      CALL bdy_orlanski_3d( idx, igrd, tsb(:,:,:,jp_sal), tsa(:,:,:,jp_sal), dta%sal, ll_npo )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_tra_orlanski')
-      !
-   END SUBROUTINE bdy_tra_orlanski
-
-
-   SUBROUTINE bdy_tra_rnf( idx, dta, kt )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra_rnf  ***
-      !!                    
-      !! ** Purpose : Apply the runoff values for tracers at open boundaries:
-      !!                  - specified to 0.1 PSU for the salinity
-      !!                  - duplicate the value for the temperature
-      !! 
-      !!----------------------------------------------------------------------
-      INTEGER        , INTENT(in) ::   kt    ! 
-      TYPE(OBC_INDEX), INTENT(in) ::   idx   ! OBC indices
-      TYPE(OBC_DATA) , INTENT(in) ::   dta   ! OBC external data
+      TYPE(OBC_INDEX),                     INTENT(in) ::   idx  ! OBC indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pta  ! tracer trend
+      INTEGER,                             INTENT(in) ::   jpa  ! TRA index
       !
       REAL(wp) ::   zwgt           ! boundary weight
@@ -248,5 +95,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('bdy_tra_rnf')
+      IF( nn_timing == 1 )   CALL timing_start('bdy_rnf')
       !
       igrd = 1                       ! Everything is at T-points here
@@ -257,15 +104,12 @@
             ip = bdytmask(ii+1,ij  ) - bdytmask(ii-1,ij  )
             jp = bdytmask(ii  ,ij+1) - bdytmask(ii  ,ij-1)
-            tsa(ii,ij,ik,jp_tem) = tsa(ii+ip,ij+jp,ik,jp_tem) * tmask(ii,ij,ik)
-            tsa(ii,ij,ik,jp_sal) =                        0.1 * tmask(ii,ij,ik)
+            if (jpa == jp_tem) pta(ii,ij,ik) = pta(ii+ip,ij+jp,ik) * tmask(ii,ij,ik)
+            if (jpa == jp_sal) pta(ii,ij,ik) =                 0.1 * tmask(ii,ij,ik)
          END DO
       END DO
       !
-      IF( kt == nit000 )   CLOSE( unit = 102 )
+      IF( nn_timing == 1 )   CALL timing_stop('bdy_rnf')
       !
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_tra_rnf')
-      !
-   END SUBROUTINE bdy_tra_rnf
-
+   END SUBROUTINE bdy_rnf
 
    SUBROUTINE bdy_tra_dmp( kt )
@@ -308,18 +152,4 @@
    END SUBROUTINE bdy_tra_dmp
  
-#else
-   !!----------------------------------------------------------------------
-   !!   Dummy module                   NO Unstruct Open Boundary Conditions
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE bdy_tra(kt)      ! Empty routine
-      WRITE(*,*) 'bdy_tra: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_tra
-
-   SUBROUTINE bdy_tra_dmp(kt)      ! Empty routine
-      WRITE(*,*) 'bdy_tra_dmp: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_tra_dmp
-#endif
-
    !!======================================================================
 END MODULE bdytra
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 7299)
@@ -9,8 +9,4 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
-   !!----------------------------------------------------------------------
-#if defined key_bdy
-   !!----------------------------------------------------------------------
-   !!   'key_bdy'                     unstructured open boundary conditions
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers 
@@ -175,14 +171,4 @@
    END SUBROUTINE bdy_vol
 
-#else
-   !!----------------------------------------------------------------------
-   !!   Dummy module                   NO Unstruct Open Boundary Conditions
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE bdy_vol( kt )        ! Empty routine
-      WRITE(*,*) 'bdy_vol: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_vol
-#endif
-
    !!======================================================================
 END MODULE bdyvol
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90	(revision 7299)
@@ -6,8 +6,7 @@
    !! History :  3.1  !  2007  (O. Le Galloudec, J. Chanut)  Original code
    !!----------------------------------------------------------------------
-#if defined key_diaharm && defined key_tide
+#if defined key_diaharm
    !!----------------------------------------------------------------------
    !!   'key_diaharm'
-   !!   'key_tide'
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -16,4 +15,5 @@
    USE daymod
    USE tide_mod
+   USE sbctide         ! Tidal forcing or not
    !
    USE in_out_manager  ! I/O units
@@ -82,4 +82,6 @@
          WRITE(numout,*) '~~~~~~~ '
       ENDIF
+      !
+      IF( .NOT. ln_tide )   CALL ctl_stop( 'dia_harm_init : ln_tide must be true for harmonic analysis')
       !
       CALL tide_init_Wave
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 7299)
@@ -23,6 +23,6 @@
    USE trabbc          ! bottom boundary condition 
    USE trabbc          ! bottom boundary condition
-   USE bdy_par         ! (for lk_bdy)
    USE restart         ! ocean restart
+   USE bdy_oce   , ONLY: ln_bdy
    !
    USE iom             ! I/O manager
@@ -395,5 +395,5 @@
       surf_tot  = glob_sum( surf(:,:) )                                       ! total ocean surface area
 
-      IF( lk_bdy ) CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
+      IF( ln_bdy ) CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
       !
       ! ---------------------------------- !
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 7299)
@@ -88,5 +88,5 @@
       !!      are defined with the proper value at lateral domain boundaries.
       !!
-      !!      In case of open boundaries (lk_bdy=T):
+      !!      In case of open boundaries (ln_bdy=T):
       !!        - tmask is set to 1 on the points to be computed bay the open
       !!          boundaries routines.
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 7299)
@@ -32,5 +32,5 @@
    USE dynspg_ts      ! surface pressure gradient: split-explicit scheme
    USE domvvl         ! variable volume
-   USE bdy_oce        ! ocean open boundary conditions
+   USE bdy_oce   , ONLY: ln_bdy
    USE bdydta         ! ocean open boundary conditions
    USE bdydyn         ! ocean open boundary conditions
@@ -77,5 +77,5 @@
       !!              * Apply lateral boundary conditions on after velocity 
       !!             at the local domain boundaries through lbc_lnk call,
-      !!             at the one-way open boundaries (lk_bdy=T),
+      !!             at the one-way open boundaries (ln_bdy=T),
       !!             at the AGRIF zoom   boundaries (lk_agrif=T)
       !!
@@ -147,12 +147,9 @@
       CALL lbc_lnk( va, 'V', -1. ) 
       !
-# if defined key_bdy
       !                                !* BDY open boundaries
-      IF( lk_bdy .AND. ln_dynspg_exp )   CALL bdy_dyn( kt )
-      IF( lk_bdy .AND. ln_dynspg_ts  )   CALL bdy_dyn( kt, dyn3d_only=.true. )
+      IF( ln_bdy .AND. ln_dynspg_exp )   CALL bdy_dyn( kt )
+      IF( ln_bdy .AND. ln_dynspg_ts  )   CALL bdy_dyn( kt, dyn3d_only=.true. )
 
 !!$   Do we need a call to bdy_vol here??
-      !
-# endif
       !
       IF( l_trddyn ) THEN             ! prepare the atf trend computation + some diagnostics
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 7299)
@@ -88,5 +88,5 @@
       !
       IF(      ln_apr_dyn                                                &   ! atmos. pressure
-         .OR.  ( .NOT.ln_dynspg_ts .AND. (ln_tide_pot .AND. lk_tide) )   &   ! tide potential (no time slitting)
+         .OR.  ( .NOT.ln_dynspg_ts .AND. (ln_tide_pot .AND. ln_tide) )   &   ! tide potential (no time slitting)
          .OR.  nn_ice_embd == 2  ) THEN                                      ! embedded sea-ice
          !
@@ -111,5 +111,5 @@
          !
          !                                    !==  tide potential forcing term  ==!
-         IF( .NOT.ln_dynspg_ts .AND. ( ln_tide_pot .AND. lk_tide )  ) THEN   ! N.B. added directly at sub-time-step in ts-case
+         IF( .NOT.ln_dynspg_ts .AND. ( ln_tide_pot .AND. ln_tide )  ) THEN   ! N.B. added directly at sub-time-step in ts-case
             !
             CALL upd_tide( kt )                      ! update tide potential
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7299)
@@ -33,5 +33,5 @@
    USE dynvor          ! vorticity term
    USE wet_dry         ! wetting/drying flux limter
-   USE bdy_par         ! for lk_bdy
+   USE bdy_oce   , ONLY: ln_bdy
    USE bdytides        ! open boundary condition data
    USE bdydyn2d        ! open boundary conditions on barotropic variables
@@ -607,8 +607,6 @@
          !                                                !  ------------------
          ! Update only tidal forcing at open boundaries
-#if defined key_tide
-         IF( lk_bdy      .AND. lk_tide )   CALL bdy_dta_tides( kt, kit=jn, time_offset= noffset+1 )
-         IF( ln_tide_pot .AND. lk_tide )   CALL upd_tide     ( kt, kit=jn, time_offset= noffset   )
-#endif
+         IF( ln_bdy      .AND. ln_tide )   CALL bdy_dta_tides( kt, kit=jn, time_offset= noffset+1 )
+         IF( ln_tide_pot .AND. ln_tide )   CALL upd_tide     ( kt, kit=jn, time_offset= noffset   )
          !
          ! Set extrapolation coefficients for predictor step:
@@ -705,8 +703,7 @@
          CALL lbc_lnk( ssha_e, 'T',  1._wp )
 
-#if defined key_bdy
          ! Duplicate sea level across open boundaries (this is only cosmetic if linssh=T)
-         IF( lk_bdy )   CALL bdy_ssh( ssha_e )
-#endif
+         IF( ln_bdy )   CALL bdy_ssh( ssha_e )
+
 #if defined key_agrif
          IF( .NOT.Agrif_Root() )   CALL agrif_ssh_ts( jn )
@@ -861,5 +858,5 @@
          !
          ! Add tidal astronomical forcing if defined
-         IF ( lk_tide.AND.ln_tide_pot ) THEN
+         IF ( ln_tide.AND.ln_tide_pot ) THEN
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -967,8 +964,7 @@
          CALL lbc_lnk_multi( ua_e, 'U', -1._wp, va_e , 'V', -1._wp )
          !
-#if defined key_bdy  
          !                                                 ! open boundaries
-         IF( lk_bdy )   CALL bdy_dyn2d( jn, ua_e, va_e, un_e, vn_e, hur_e, hvr_e, ssha_e )
-#endif
+         IF( ln_bdy )   CALL bdy_dyn2d( jn, ua_e, va_e, un_e, vn_e, hur_e, hvr_e, ssha_e )
+
 #if defined key_agrif                                                           
          IF( .NOT.Agrif_Root() )  CALL agrif_dyn_ts( jn )  ! Agrif
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7299)
@@ -22,6 +22,5 @@
    USE divhor         ! horizontal divergence
    USE phycst         ! physical constants
-   USE bdy_oce        ! 
-   USE bdy_par        !
+   USE bdy_oce   , ONLY: ln_bdy, bdytmask
    USE bdydyn2d       ! bdy_ssh routine
 #if defined key_agrif
@@ -116,10 +115,8 @@
          CALL agrif_ssh( kt )
 # endif
-# if defined key_bdy
-         IF( lk_bdy ) THEN
+         IF( ln_bdy ) THEN
             CALL lbc_lnk( ssha, 'T', 1. )    ! Not sure that's necessary
             CALL bdy_ssh( ssha )             ! Duplicate sea level across open boundaries
          ENDIF
-# endif
       ENDIF
 
@@ -211,11 +208,9 @@
       ENDIF
 
-#if defined key_bdy
-      IF( lk_bdy ) THEN
+      IF( ln_bdy ) THEN
          DO jk = 1, jpkm1
             wn(:,:,jk) = wn(:,:,jk) * bdytmask(:,:)
          END DO
       ENDIF
-#endif
       !
       IF( nn_timing == 1 )  CALL timing_stop('wzv')
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 7299)
@@ -666,7 +666,6 @@
       !!                using a general mapping (for open boundaries)
       !!----------------------------------------------------------------------
-#if defined key_bdy
-      USE bdy_oce, ONLY:  dta_global, dta_global2         ! workspace to read in global data arrays
-#endif 
+      USE bdy_oce, ONLY: ln_bdy, dta_global, dta_global2         ! workspace to read in global data arrays
+
       INTEGER                   , INTENT(in ) ::   num     ! stream number
       CHARACTER(LEN=*)          , INTENT(in ) ::   clvar   ! variable name
@@ -692,12 +691,12 @@
       ilendta = iom_file(num)%dimsz(1,idvar)
 
-#if defined key_bdy
-      ipj = iom_file(num)%dimsz(2,idvar)
-      IF( map%ll_unstruc) THEN   ! unstructured open boundary data file
-         dta_read => dta_global
-      ELSE                       ! structured open boundary data file
-         dta_read => dta_global2
-      ENDIF
-#endif
+      IF ( ln_bdy ) THEN
+         ipj = iom_file(num)%dimsz(2,idvar)
+         IF( map%ll_unstruc) THEN   ! unstructured open boundary data file
+            dta_read => dta_global
+         ELSE                       ! structured open boundary data file
+            dta_read => dta_global2
+         ENDIF
+      ENDIF
 
       IF(lwp) WRITE(numout,*) 'Dim size for ',        TRIM(clvar),' is ', ilendta
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7299)
@@ -62,7 +62,6 @@
    USE timing          ! Timing
 
-#if defined key_bdy 
-   USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
-#endif
+   USE bdy_oce   , ONLY: ln_bdy
+   USE bdyice_lim      ! unstructured open boundary data  (bdy_ice_lim routine)
 
    IMPLICIT NONE
@@ -166,8 +165,6 @@
             IF( nn_monocat /= 2 ) CALL lim_itd_me ! Mechanical redistribution ! (ridging/rafting)
             !
-#if defined key_bdy
-            CALL bdy_ice_lim( kt )                ! bdy ice thermo 
-            IF( ln_icectl )       CALL lim_prt( kt, iiceprt, jiceprt, 1, ' - ice thermo bdy - ' )
-#endif
+            IF( ln_bdy )  CALL bdy_ice_lim( kt )                ! bdy ice thermo 
+            IF( ln_bdy .AND. ln_icectl )  CALL lim_prt( kt, iiceprt, jiceprt, 1, ' - ice thermo bdy - ' )
             !
             CALL lim_update1( kt )                ! Corrections
@@ -380,7 +377,6 @@
       r1_nlay_s = 1._wp / REAL( nlay_s, wp )
       !
-#if defined key_bdy
-      IF( lwp .AND. ln_limdiahsb )  CALL ctl_warn('online conservation check activated but it does not work with BDY')
-#endif
+      IF( lwp .AND. ln_bdy .AND. ln_limdiahsb )  &
+      &   CALL ctl_warn('online conservation check activated but it does not work with BDY')
       !
    END SUBROUTINE ice_run
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 7299)
@@ -54,7 +54,6 @@
 # endif
 
-#if defined key_bdy 
+   USE bdy_oce   , ONLY: ln_bdy
    USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
-#endif
 
    IMPLICIT NONE
@@ -230,7 +229,5 @@
                            CALL lim_trp_2      ( kt )      ! Ice transport   ( Advection/diffusion )
            IF( ln_limdmp ) CALL lim_dmp_2      ( kt )      ! Ice damping 
-#if defined key_bdy
-                           CALL bdy_ice_lim( kt ) ! bdy ice thermo
-#endif
+           IF( ln_bdy    ) CALL bdy_ice_lim( kt ) ! bdy ice thermo
          END IF
          !                                             ! Ice surface fluxes in coupled mode 
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7298)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7299)
@@ -47,5 +47,5 @@
    USE traqsr         ! active tracers: light penetration
    USE sbcwave        ! Wave module
-   USE bdy_par        ! Require lk_bdy
+   USE bdy_oce   , ONLY: ln_bdy
    !
    USE prtctl         ! Print control                    (prt_ctl routine)
